#!/usr/bin/perl

# Online Status CGI for Regnessem
# Copyright (C) 2004 Moon (moon@users.sourceforge.jp)

use Socket;
require 'cgi-lib.pl';
parseDataFile('config.txt', \%config);

# Main Routine-------------------------------------------------------
main: {
	my %input;
	ReadParse(\%input);
	#
	if ($input{'id'} eq "") {
		print PrintHeader();
		print HtmlTop('Error');
		print "<p>ID is empty</p>";
		print HtmlBottom();
		exit;
	}
	#
	if ($input{'action'} eq "regist") {
		if ($input{'pass'} ne $config{'pass'}) {
			showMessage('Error', 'Invalid Password');
		}
		recordLog($config{'log'}, $input{'id'});
		showMessage('Record', "Record OK (".time.")");
	} elsif ($input{'action'} eq "view") {
		my (@logdata, @data);
		my $dir;
		if ($input{'image'} eq "") {
			$dir = $config{'image_default'};
		} else {
			$dir = $input{'image'};
		}
		parseListFile($config{'log'}, \@logdata);
		foreach (@logdata) {
			@data = split /<>/;
			if ($data[0] eq $input{'id'}) {
				if ($data[1] + $config{'timeout'} < time) {
					if ($input{'off'} eq "") {
						showImageFile("$dir/$config{'image_0'}", 'png');
					} else {
						showImageData($input{'off'});
					}
				} else {
					if ($input{'on'} eq "") {
						showImageFile("$dir/$config{'image_1'}", 'png');
					} else {
						showImageData($input{'on'});
					}
				}
			}
		}
		showMessage('Error', 'No ID Found');
	} else {
		showMessage('Error', 'Invalid Access');
	}
}

sub showImageFile {
	my $filename = shift;
	my $type = shift;
	open IMG, $filename;
	binmode IMG;
	binmode STDOUT;
	print qq(Content-Type: image/$type\n\n);
	print while(<IMG>);
	close IMG;
	exit;
}

sub showImageData {
	my $url = shift;
	my $type;
	my @data;
	my $host;
	my $file;
	($host) = $url =~ /http:\/\/([-_\.a-zA-Z0-9]+)\/?.*/;
	($file) = $url =~ /http:\/\/[-_\.a-zA-Z0-9]+\/?(.*)/;
	getInternetFile($host, $file, \$type, \@data);
	print "Content-Type: $type\n\n";
	print @data;
	exit;
}

# --File Parser------------------------------------------------------
# Data File Parser
sub parseDataFile {
	my $file = shift;
	my $r_hash = shift;
	undef %{$r_hash};
	open FILE, $file;
	foreach (<FILE>) {
		next if (/^#/);
		s/[\r\n]//g;
		s/\s+$//g;
		($key, $value) = $_ =~ /([\s\S]*?) ([\s\S]*)$/;
		$key =~ s/\s//g;
		if ($key eq "") {
			($key) = $_ =~ /([\s\S]*)$/;
			$key =~ s/\s//g;
		}
		if ($key ne "") {
			$$r_hash{$key} = $value;
		}
	}
	close FILE;
}
# List File Parser
sub parseListFile {
	my $file = shift;
	my $r_list = shift;
	my $i = 0;
	undef @{$r_list};
	open FILE, $file;
	foreach (<FILE>) {
		next if (/^#/);
		s/\r//g;
		s/\n//g;
		if ($_ ne "") {
			$$r_list[$i++] = $_;
		}
	}
	close FILE;
}
# Recode Log
sub recordLog {
	my $logfile = shift;
	my $id = shift;
	my (@logdata, @data, @newlogdata);
	my $found = 0;
	parseListFile($logfile, \@logdata);
	foreach (@logdata) {
		@data = split /<>/;
		if ($data[0] eq $id) {
			push @newlogdata, join('<>', $id, time);
			$found = 1;
		} else {
			push @newlogdata, $_;
		}
	}
	unless ($found) {
		push @newlogdata, join('<>', $id, time);
	}
	writeFile($logfile, @newlogdata);
	return $found;
}
#
sub writeFile {
	my $filename = shift;
	my @data = @_;
	unless (-e $filename) {
		open FILE, ">$filename";
		close FILE;
	}
	if (open(FILE, "+<$filename")) {
		eval(flock(FILE, 2));
		truncate(FILE, 0);
		seek(FILE, 0, 0);
		foreach (@data) {
			print FILE $_."\n";
		}
		#eval(flock(FILE, 8));
		close FILE;
	} else {
		showMessage('Error', "Can't Open File");
	}
}

sub getTime {
	my($sec, $min, $hour, $date, $mon, $year, $day, $yday, $dummy) = gmtime(time);
	# 2P^
	$year += 1900;
	if ($date < 10) { $date = "0$date"; }
	if ($hour < 10) { $hour = "0$hour"; }
	if ($min < 10)  { $min  = "0$min"; }
	if ($sec < 10)  { $sec  = "0$sec"; }
	# j𕶎
	$day = ("Sun", "Mon", "Tue", "Wed",
			"Thud", "Fri", "Sat")[$day];
	# 𕶎
	$mon = ("Jan", "Feb", "Mar", "Apr", "May", "Jun",
			"Jul", "Aug", "Sep", "Oct", "Nov", "Dec")[$mon];
	return "$day, $date $mon $year $hour:$min:$sec GMT";
}
# Tiny HTTP-Client
sub getInternetFile {
	my $host = shift;
	my $file = shift;
	my $type = shift;
	my $data = shift;
	my $port = getservbyname('http', 'tcp');
	my $iaddr = inet_aton($host) or showMessage('Error', 'can not find host');
	my $sock_addr = pack_sockaddr_in($port, $iaddr);
	undef @{$data};
	socket(SOCKET, PF_INET, SOCK_STREAM, 0) or showMessage('Error', 'socket create error');
	connect(SOCKET, $sock_addr) or showMessage('Error', 'connect error');
	select(SOCKET); $| = 1; select(STDOUT);
	print SOCKET "GET /$file HTTP/1.0\r\n";
	print SOCKET "Host:$host:$port\r\n";
	print SOCKET "\r\n";
	while (<SOCKET>) {
		if ($_ =~ /Content-Type/) {
			($$type) = $_ =~ /Content-Type: (.*);/;
		}
		m/^\r\n/ and last;
	}
	while (<SOCKET>) {
		push @{$data}, $_;
	}
	close SOCKET;
}

sub showMessage {
	my $header = shift;
	my $comment = shift;
	print "Last-Modified:".getTime()."\n";
	print PrintHeader();
	print HtmlTop($header);
	print "<p>$comment</p>";
	print HtmlBottom();
	exit;
}
